package dev.fyloz.trial.colorrecipesexplorer.rest

import dev.fyloz.trial.colorrecipesexplorer.model.MaterialQuantityDto
import dev.fyloz.trial.colorrecipesexplorer.model.MixDeductDto
import dev.fyloz.trial.colorrecipesexplorer.service.InventoryService
import org.springframework.context.annotation.Profile
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

private const val INVENTORY_CONTROLLER_PATH = "api/inventory"

@RestController
@RequestMapping(INVENTORY_CONTROLLER_PATH)
@Profile("rest")
class InventoryController(
    private val inventoryService: InventoryService
) {
    @PutMapping("add")
    fun add(@RequestBody quantities: Collection<MaterialQuantityDto>): ResponseEntity<Collection<MaterialQuantityDto>> {
        return ResponseEntity.ok(inventoryService.add(quantities))
    }

    @PutMapping("deduct")
    fun deduct(@RequestBody quantities: Collection<MaterialQuantityDto>): ResponseEntity<Collection<MaterialQuantityDto>> {
        return ResponseEntity.ok(inventoryService.deduct(quantities))
    }

    @PutMapping("deduct/mix")
    fun deduct(@RequestBody mixRatio: MixDeductDto): ResponseEntity<Collection<MaterialQuantityDto>> {
        return ResponseEntity.ok(inventoryService.deductMix(mixRatio))
    }
}
